	.text	0x00400000
	.globl	main
	la	$28, _heap_
	la	$4, _a__str__39_
# was:	la	_a__str__39__addr, _a__str__39_
	ori	$3, $0, 1
# was:	ori	_a__str__39__init, $0, 1
	sw	$3, 0($4)
# was:	sw	_a__str__39__init, 0(_a__str__39__addr)
	la	$4, _a__str__29_
# was:	la	_a__str__29__addr, _a__str__29_
	ori	$3, $0, 1
# was:	ori	_a__str__29__init, $0, 1
	sw	$3, 0($4)
# was:	sw	_a__str__29__init, 0(_a__str__29__addr)
	la	$4, _a__str__22_
# was:	la	_a__str__22__addr, _a__str__22_
	ori	$3, $0, 1
# was:	ori	_a__str__22__init, $0, 1
	sw	$3, 0($4)
# was:	sw	_a__str__22__init, 0(_a__str__22__addr)
	la	$4, _a__str__15_
# was:	la	_a__str__15__addr, _a__str__15_
	ori	$3, $0, 1
# was:	ori	_a__str__15__init, $0, 1
	sw	$3, 0($4)
# was:	sw	_a__str__15__init, 0(_a__str__15__addr)
	la	$4, _a__str__8_
# was:	la	_a__str__8__addr, _a__str__8_
	ori	$3, $0, 1
# was:	ori	_a__str__8__init, $0, 1
	sw	$3, 0($4)
# was:	sw	_a__str__8__init, 0(_a__str__8__addr)
	la	$4, _true
# was:	la	_true_addr, _true
	ori	$3, $0, 4
# was:	ori	_true_init, $0, 4
	sw	$3, 0($4)
# was:	sw	_true_init, 0(_true_addr)
	la	$3, _false
# was:	la	_false_addr, _false
	ori	$4, $0, 5
# was:	ori	_false_init, $0, 5
	sw	$4, 0($3)
# was:	sw	_false_init, 0(_false_addr)
	jal	main
_stop_:
	ori	$2, $0, 10
	syscall
# Function main
main:
	sw	$31, -4($29)
	sw	$20, -24($29)
	sw	$19, -20($29)
	sw	$18, -16($29)
	sw	$17, -12($29)
	sw	$16, -8($29)
	addi	$29, $29, -28
	ori	$17, $0, 1
# was:	ori	_tmp_4_, $0, 1
# 	ori	_letBind_3_,_tmp_4_,0
	la	$2, _true
# was:	la	$2, _true
	bne	$17, $0, _wBoolF_5_
# was:	bne	_letBind_3_, $0, _wBoolF_5_
	la	$2, _false
# was:	la	$2, _false
_wBoolF_5_:
	jal	putstring
# was:	jal	putstring, $2
	la	$2, _a__str__8_
# was:	la	_tmp_7_, _a__str__8_
# _a__str__8_: string "\n"
# 	ori	_letBind_6_,_tmp_7_,0
# 	ori	$2,_tmp_7_,0
	jal	putstring
# was:	jal	putstring, $2
# 	ori	_letBind_2_,_letBind_3_,0
	ori	$18, $0, 0
# was:	ori	_tmp_11_, $0, 0
# 	ori	_letBind_10_,_tmp_11_,0
	la	$2, _true
# was:	la	$2, _true
	bne	$18, $0, _wBoolF_12_
# was:	bne	_letBind_10_, $0, _wBoolF_12_
	la	$2, _false
# was:	la	$2, _false
_wBoolF_12_:
	jal	putstring
# was:	jal	putstring, $2
	la	$2, _a__str__15_
# was:	la	_tmp_14_, _a__str__15_
# _a__str__15_: string "\n"
# 	ori	_letBind_13_,_tmp_14_,0
# 	ori	$2,_tmp_14_,0
	jal	putstring
# was:	jal	putstring, $2
# 	ori	_letBind_9_,_letBind_10_,0
	ori	$19, $0, 0
# was:	ori	_tmp_18_, $0, 0
# 	ori	_letBind_17_,_tmp_18_,0
	la	$2, _true
# was:	la	$2, _true
	bne	$19, $0, _wBoolF_19_
# was:	bne	_letBind_17_, $0, _wBoolF_19_
	la	$2, _false
# was:	la	$2, _false
_wBoolF_19_:
	jal	putstring
# was:	jal	putstring, $2
	la	$2, _a__str__22_
# was:	la	_tmp_21_, _a__str__22_
# _a__str__22_: string "\n"
# 	ori	_letBind_20_,_tmp_21_,0
# 	ori	$2,_tmp_21_,0
	jal	putstring
# was:	jal	putstring, $2
# 	ori	_letBind_16_,_letBind_17_,0
	ori	$20, $0, 1
# was:	ori	_tmp_25_, $0, 1
# 	ori	_letBind_24_,_tmp_25_,0
	la	$2, _true
# was:	la	$2, _true
	bne	$20, $0, _wBoolF_26_
# was:	bne	_letBind_24_, $0, _wBoolF_26_
	la	$2, _false
# was:	la	$2, _false
_wBoolF_26_:
	jal	putstring
# was:	jal	putstring, $2
	la	$2, _a__str__29_
# was:	la	_tmp_28_, _a__str__29_
# _a__str__29_: string "\n"
# 	ori	_letBind_27_,_tmp_28_,0
# 	ori	$2,_tmp_28_,0
	jal	putstring
# was:	jal	putstring, $2
# 	ori	_letBind_23_,_letBind_24_,0
# 	ori	_letBind_30_,_letBind_2_,0
	beq	$17, $16, _false_33_
# was:	beq	_letBind_30_, 0, _false_33_
	ori	$17, $18, 0
# was:	ori	_letBind_30_, _letBind_9_, 0
_false_33_:
	beq	$17, $16, _false_32_
# was:	beq	_letBind_30_, 0, _false_32_
	ori	$17, $19, 0
# was:	ori	_letBind_30_, _letBind_16_, 0
_false_32_:
	beq	$17, $16, _false_31_
# was:	beq	_letBind_30_, 0, _false_31_
	ori	$17, $20, 0
# was:	ori	_letBind_30_, _letBind_23_, 0
_false_31_:
	ori	$16, $17, 0
# was:	ori	_tmp_35_, _letBind_30_, 0
# 	ori	_letBind_34_,_tmp_35_,0
	la	$2, _true
# was:	la	$2, _true
	bne	$16, $0, _wBoolF_36_
# was:	bne	_letBind_34_, $0, _wBoolF_36_
	la	$2, _false
# was:	la	$2, _false
_wBoolF_36_:
	jal	putstring
# was:	jal	putstring, $2
	la	$2, _a__str__39_
# was:	la	_tmp_38_, _a__str__39_
# _a__str__39_: string "\n"
# 	ori	_letBind_37_,_tmp_38_,0
# 	ori	$2,_tmp_38_,0
	jal	putstring
# was:	jal	putstring, $2
	ori	$2, $16, 0
# was:	ori	_mainres_1_, _letBind_34_, 0
# 	ori	$2,_mainres_1_,0
	addi	$29, $29, 28
	lw	$20, -24($29)
	lw	$19, -20($29)
	lw	$18, -16($29)
	lw	$17, -12($29)
	lw	$16, -8($29)
	lw	$31, -4($29)
	jr	$31
ord:
	jr	$31
chr:
	andi	$2, $2, 255
	jr	$31
putint:
	addi	$29, $29, -8
	sw	$2, 0($29)
	sw	$4, 4($29)
	ori	$4, $2, 0
	ori	$2, $0, 1
	syscall
	ori	$2, $0, 4
	la	$4, _space_
	syscall
	lw	$2, 0($29)
	lw	$4, 4($29)
	addi	$29, $29, 8
	jr	$31
getint:
	ori	$2, $0, 5
	syscall
	jr	$31
putchar:
	addi	$29, $29, -8
	sw	$2, 0($29)
	sw	$4, 4($29)
	ori	$4, $2, 0
	ori	$2, $0, 11
	syscall
	ori	$2, $0, 4
	la	$4, _space_
	syscall
	lw	$2, 0($29)
	lw	$4, 4($29)
	addi	$29, $29, 8
	jr	$31
getchar:
	addi	$29, $29, -8
	sw	$4, 0($29)
	sw	$5, 4($29)
	ori	$2, $0, 12
	syscall
	ori	$5, $2, 0
	ori	$2, $0, 4
	la	$4, _cr_
	syscall
	ori	$2, $5, 0
	lw	$4, 0($29)
	lw	$5, 4($29)
	addi	$29, $29, 8
	jr	$31
putstring:
	addi	$29, $29, -16
	sw	$2, 0($29)
	sw	$4, 4($29)
	sw	$5, 8($29)
	sw	$6, 12($29)
	lw	$4, 0($2)
	addi	$5, $2, 4
	add	$6, $5, $4
	ori	$2, $0, 11
putstring_begin:
	sub	$4, $5, $6
	bgez	$4, putstring_done
	lb	$4, 0($5)
	syscall
	addi	$5, $5, 1
	j	putstring_begin
putstring_done:
	lw	$2, 0($29)
	lw	$4, 4($29)
	lw	$5, 8($29)
	lw	$6, 12($29)
	addi	$29, $29, 16
	jr	$31
_RuntimeError_:
	la	$4, _ErrMsg_
	ori	$2, $0, 4
	syscall
	ori	$4, $5, 0
	ori	$2, $0, 1
	syscall
	la	$4, _colon_space_
	ori	$2, $0, 4
	syscall
	ori	$4, $6, 0
	ori	$2, $0, 4
	syscall
	la	$4, _cr_
	ori	$2, $0, 4
	syscall
	j	_stop_
	.data	
# Fixed strings for I/O
_ErrMsg_:
	.asciiz	"Runtime error at line "
_colon_space_:
	.asciiz	": "
_cr_:
	.asciiz	"\n"
_space_:
	.asciiz	" "
# Message strings for specific errors
_Msg_IllegalArraySize_:
	.asciiz	"negative array size"
_Msg_IllegalIndex_:
	.asciiz	"array index out of bounds"
_Msg_DivZero_:
	.asciiz	"division by zero"
# String Literals
	.align	2
_a__str__39_:
	.space	4
	.asciiz	"\n"
	.align	2
_a__str__29_:
	.space	4
	.asciiz	"\n"
	.align	2
_a__str__22_:
	.space	4
	.asciiz	"\n"
	.align	2
_a__str__15_:
	.space	4
	.asciiz	"\n"
	.align	2
_a__str__8_:
	.space	4
	.asciiz	"\n"
	.align	2
_true:
	.space	4
	.asciiz	"true"
	.align	2
_false:
	.space	4
	.asciiz	"false"
	.align	2
_heap_:
	.space	100000